﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Diagnostics;

namespace howto_check_string_blank
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Uncomment the following if running .NET Framework 4.5 or later.
            label6.Enabled = true;
            txtIsNullOrWhiteSpace.Enabled = true;
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            txtEmpty.Clear();
            txtCompareTo.Clear();
            txtQuote.Clear();
            txtLength.Clear();
            txtIsNullOrEmpty.Clear();
            txtIsNullOrWhiteSpace.Clear();

            Cursor = Cursors.WaitCursor;
            int num_trials = int.Parse(txtNumTrials.Text);
            Stopwatch watch = new Stopwatch();
            string string1 = "", string2 = "ABCD", string3;
            Refresh();

            watch.Start();
            for (int i = 0; i < num_trials; i++)
            {
                if (string1 == string.Empty) string3 = string1;
                if (string2 == string.Empty) string3 = string2;
            }
            watch.Stop();
            txtEmpty.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " sec";
            Refresh();

            watch.Restart();
            for (int i = 0; i < num_trials; i++)
            {
                if (string1.CompareTo(string.Empty) == 0) string3 = string1;
                if (string2.CompareTo(string.Empty) == 0) string3 = string2;
            }
            watch.Stop();
            txtCompareTo.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " sec";
            Refresh();

            watch.Restart();
            for (int i = 0; i < num_trials; i++)
            {
                if (string1 == "") string3 = string1;
                if (string2 == "") string3 = string2;
            }
            watch.Stop();
            txtQuote.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " sec";
            Refresh();

            watch.Restart();
            for (int i = 0; i < num_trials; i++)
            {
                if (string1.Length == 0) string3 = string1;
                if (string2.Length == 0) string3 = string2;
            }
            watch.Stop();
            txtLength.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " sec";
            Refresh();

            watch.Restart();
            for (int i = 0; i < num_trials; i++)
            {
                if (string.IsNullOrEmpty(string1)) string3 = string1;
                if (string.IsNullOrEmpty(string2)) string3 = string2;
            }
            watch.Stop();
            txtIsNullOrEmpty.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " sec";
            Refresh();

            // Uncomment the following if running .NET Framework 4.5 or later.
            watch.Start();
            for (int i = 0; i < num_trials; i++)
            {
                if (string.IsNullOrWhiteSpace(string1)) string3 = string1;
                if (string.IsNullOrWhiteSpace(string2)) string3 = string2;
            }
            watch.Stop();
            txtIsNullOrWhiteSpace.Text = watch.Elapsed.TotalSeconds.ToString("0.00") + " sec";
            Refresh();

            Cursor = Cursors.Default;
        }
    }
}
